/*
 * This file is a part of EpnTAPClient.
 * This program aims to provide EPN-TAP support for software clients, like CASSIS spectrum analyzer.
 * See draft specifications: https://voparis-confluence.obspm.fr/pages/viewpage.action?pageId=559861
 * Copyright (C) 2016 Institut de Recherche en Astrophysique et Planétologie.
 *
 * This program is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or (at your option) any later
 * version. This program is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU General Public License for more details. You should have received a copy of
 * the GNU General Public License along with this program. If not, see
 * <http://www.gnu.org/licenses/>.
 */

package eu.omp.irap.vespa.votable.utils;

import java.io.FileWriter;
import java.io.IOException;
import java.util.logging.Logger;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;

import eu.omp.irap.vespa.votable.Consts;

/**
 * @author N. Jourdane
 */
public class Debug {

	/** The logger for the class Debug. */
	private static final Logger LOGGER = Logger.getLogger(Debug.class.getName());


	/** Private constructor to hide the implicit public one. */
	private Debug() {
	}

	/**
	 * @param object An object to serialize.
	 * @return The serialized JSon representation of a given object.
	 */
	public static String toJson(Object object) {
		return new GsonBuilder().serializeSpecialFloatingPointValues().create().toJson(object);
	}

	/**
	 * Print the specified object in JSON format in a file on the temporary directory.
	 *
	 * @param title The name of the file.
	 * @param obj the object to print in a file.
	 * @return The path of the file.
	 */
	public static String writeObject(String title, Object obj) {
		Gson gson = new GsonBuilder().serializeSpecialFloatingPointValues().setPrettyPrinting()
				.create();
		String json = gson.toJson(obj);
		String path = Consts.TMP_DIR + "/" + title + ".json";
		try (FileWriter writer = new FileWriter(path)) {
			writer.write(json);

		} catch (IOException e) {
			Debug.LOGGER.warning("Can not print in the file " + path + e);
		}
		Debug.LOGGER.fine("A json file representing " + title + " (" + obj.getClass().getName()
				+ ") has been created on " + path);

		return path;
	}
}
